(* Dmonstration de la coercion *)

class virtual printable = object(self)
  method print () = print_string (self#to_string ()); print_newline ()
  method virtual to_string : unit -> string
end

class point (x_init,y_init) =
object
  inherit printable
  val mutable x = x_init
  val mutable y = y_init
  method get_x = x
  method get_y = y
  method moveto (a,b) = x <- a ; y <- b 
  method rmoveto (dx,dy) = x <- x + dx ; y <- y + dy 
  method to_string  () = 
    "(" ^ (string_of_int x) ^ ", " ^ (string_of_int y) ^")"
end

class colored_point (x,y) c =
object
  inherit point (x,y) as super
  val mutable c = c
  method get_color = c
  method set_color nc = c <- nc
  method to_string () = super#to_string () ^ " [" ^ c ^ "] "
end

let x = new point (1,2);;
let y = new colored_point (3,4) "pink";;
let z = [x; y];; (* erreur de typage *)
let z = [ (x :> printable); (y :> printable) ];; (* ca marche *)
List.iter (function o -> o#print () ) z ;; (* imprimer les objets *)

(* La mme chose avec coercion vers point *)
let z = [ x; (y :> point) ];; (* ca marche *)
List.iter (function o -> o#print () ) z ;; (* imprimer les objets *)

(* c'est bien la mthode print de la classe colored_point qui est excute
   pour y ! *)
