(* modification de l'exemple prcdent *)

class point (x_init,y_init) =
object(self)
  val mutable x = x_init
  val mutable y = y_init
  method get_x = x
  method get_y = y
  method moveto (a,b) = x <- a ; y <- b 
  method rmoveto (dx,dy) = x <- x + dx ; y <- y + dy 
  method to_string () = 
    "(" ^ (string_of_int x) ^ ", " ^ (string_of_int y) ^")"
  method distance () = sqrt (float(x*x + y*y))
  method print () =    (* nouvelle mthode *)
    print_string ("==> " ^ (self#to_string () ) ^ " <==\n")
end ;;

let x = new point(1,1);;
x#print ();;


(* dfinition d'une deuxime classe de points colors *)
class colored_point (x,y) c =
object
  inherit point (x,y) as super
  val mutable c = c
  method get_color = c
  method set_color nc = c <- nc
  method to_string () = super#to_string () ^ " [" ^ c ^ "] "
end ;;

let y = new colored_point(3,4) "rouge";;
y#print ();;
