(* Dmonstration du hritage multiple *)

class point (x_init,y_init) = object
  val mutable x = x_init
  val mutable y = y_init
  method get_x = x
  method get_y = y
  method moveto (a,b) = x <- a ; y <- b 
  method rmoveto (dx,dy) = x <- x + dx ; y <- y + dy 
  method to_string () = 
    "(" ^ (string_of_int x) ^ ", " ^ (string_of_int y) ^")"
end

class colored color_init = object
  val mutable c = color_init
  method set_color color_new = c <- color_new
  method to_string () = "[ " ^ c ^ " ]"
  method inverse () = c <- match c with
      "black" -> "white"
    | "white" -> "black"
    | "red" -> "green"
    | "green" -> "red"
    | any -> any
end

class colored_point (x_init,y_init) color_init = object
  inherit point (x_init,y_init) as position
  inherit colored color_init as color
  method to_string () = (position#to_string ()) ^ (color#to_string ())
end
	    
let x = new colored_point (0,0) "white";;
x#moveto (17,42);;
x#inverse ();;
x#to_string ();;
