(* Exemple d'une classe o les paramtres sont d'un type libre *)

class couple (a,b) =
object
  val p0 = a
  val p1 = b
  method to_string() = p0#to_string() ^ ", " ^ p1#to_string()
  method copy () = new couple (p0,p1)
end

class newint  i = object
  val c = i
  method to_string () = string_of_int i
end

class newstring s = object
  val c = s
  method to_string () = "[" ^ s ^ "]"
end

let x = new couple (new newint 1, new newstring "bonjour");;
let y = x#copy ();;
y#to_string ();;
