(* Dmonstration des mthode rcursives *)

class calc(initial) = object(self)
  val mutable c = initial
  method increment () = c <- c+1
  method show () = c
  method fact (i) = 
    if i = 0 
    then 1 
    else i * self#fact(i-1)
end

let x = new calc (0) ;;
x#fact(4);;


(* Simulation en OCaml sans objets *)

type calc = {
  increment: unit -> unit;
  show: unit -> int;
  fact: int -> int
}

let create_calc initial =
  let c = ref initial
  in
  let rec
    increment = (function () -> c := !c+1)
  and
    show = (function () -> !c)
  and
    fact(i) =
    if i=0
    then 1
    else i * fact (i-1)
  in
    { 
      increment = increment;
      show = show;
      fact = fact
    }

let x = create_calc 0;;
x.fact (4);;
