class point ( (x0:int) ,(y0:int) ) =
object(self: 'a)
  val x = x0
  val y = y0
  method getx = x
  method gety = y
  method equal (p:'a) = (self#getx = p#getx) && (self#gety = p#gety)
end

class colored_point ( (x0:int) ,(y0:int) ) (c0:string) =
object(self: 'a)
  inherit point(x0,y0) as super
  val c = c0
  method getc = c
  method equal (p:'a) =  
    (self#getx = p#getx) && (self#gety = p#gety) && (self#getc = p#getc)
end

let x = new point (0,1);;
x#equal x;;
let y = new colored_point (0,1) "red";;
let z = new colored_point (0,1) "black";;
y#equal z;;


(* on ne peut pas pas comparer un point avec un point color *)
x#equal y;;
y#equal x;;

(* de plus, on ne peut pas coercer un colored_point vers un point *)
(y :> point);;
