(* toujours la classe point *)
class point (x_init,y_init) =
object
  val mutable x = x_init
  val mutable y = y_init
  method get_x = x
  method get_y = y
  method moveto (a,b) = x <- a ; y <- b 
  method rmoveto (dx,dy) = x <- x + dx ; y <- y + dy 
  method to_string () = 
    "(" ^ (string_of_int x) ^ ", " ^ (string_of_int y) ^")"
end;;

(* classe drive avec une opration d'galit *)
class point_eq (x,y) = 
object (self : 'a) 
  inherit point (x,y)
  method eq (p:'a) = (self#get_x = p#get_x) && (self#get_y = p#get_y)
end ;;

(* class drive avec coleur *)
class colored_point_eq (xc,yc) c = 
object (self : 'a) 
  inherit point_eq (xc,yc) as super 
  val c = (c:string)
  method get_c = c
  method eq (pc : 'a) =  (self#get_x = pc#get_x) && (self#get_y = pc#get_y) 
                         && (self#get_c = pc#get_c)
end 
