(* Dmonstration des classes virtuelles *)

class virtual printable = object(self)
  method print () = print_string (self#to_string ()); print_newline ()
  method virtual to_string : unit -> string
end

let x = new printable;; (* erreur *)

class point (x_init,y_init) =
object
  inherit printable
  val mutable x = x_init
  val mutable y = y_init
  method get_x = x
  method get_y = y
  method moveto (a,b) = x <- a ; y <- b 
  method rmoveto (dx,dy) = x <- x + dx ; y <- y + dy 
  method to_string () = 
    "(" ^ (string_of_int x) ^ ", " ^ (string_of_int y) ^")"
end

class counter (init) =
object
  inherit printable
  val mutable c = init
  method incr = c <- c+1
  method to_string () = string_of_int c
end

let p = new point (0,1);;
p#print ();;
let q = new counter (42);;
q#print ();;
